#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <vector>
#include <string.h>

using namespace std;

typedef struct
{
    long hash;
    long folderNum;
    long fileNum;
    char* folderName;
    char* fileName;
} FileBlock;

long fileSize = 0;

char* copyFileToMemory(FILE* fp)
{
    rewind(fp);
    fseek(fp,0,SEEK_END);
    fileSize = ftell(fp);
    rewind(fp);
    char* memFile = (char*) malloc(fileSize * sizeof(char));

    long i = 0;
    for (i = 0; i < fileSize; i++)
    {
        fread(&memFile[i],sizeof(char),1,fp);
    }

    return memFile;
}

int compare (const void* a, const void* b)
{
    FileBlock fb1 = *(FileBlock*) a;
    FileBlock fb2 = *(FileBlock*) b;
    return ( fb1.fileNum - fb2.fileNum );
}


int main()
{
    FILE* fp = NULL;

    fp = fopen("script-meta-output.txt", "rb");

    if (!fp)
    {
        exit(1);
    }

    char* memFile = copyFileToMemory(fp);

    long i = 0;
    int divisionCount = 0;
    long totalBlocks = 0;
    for (i = 0; i <fileSize; i++)
    {
        if (memFile[i] == '|')
        {
            divisionCount++;
        }
        if (memFile[i] == '\n')
        {
            if (divisionCount > 0)
            {
                totalBlocks++;
            }
            divisionCount = 0;
        }
    }

    FileBlock* fileBlocks = (FileBlock*) calloc(totalBlocks, sizeof(FileBlock));

    for (i = 0; i <totalBlocks; i++)
    {
        if (i == 0)
        {
            fileBlocks[i].hash = atoi(strtok(memFile,"|"));
        }
        else
        {
            fileBlocks[i].hash = atoi(strtok(NULL,"|"));
        }
        fileBlocks[i].folderNum = atoi(strtok(NULL,"|"));
        fileBlocks[i].fileNum = atoi(strtok(NULL,"|"));
        fileBlocks[i].folderName = strtok(NULL,"|");
        fileBlocks[i].fileName = strtok(NULL,"\n");
    }



    long count = 0;
    qsort(fileBlocks,totalBlocks,sizeof(FileBlock),compare);

    for (i = 0; i <totalBlocks; i++)
    {
        if ( i > 0)
        {
            //printf("\n%ld %ld  (%d)",fileBlocks[i].fileNum , (fileBlocks[i -1].fileNum + 1), fileBlocks[i].fileNum != (long)(fileBlocks[i -1].fileNum + 1));
           if(fileBlocks[i].fileNum != (long)(fileBlocks[i -1].fileNum + 1))
            {
                /*printf("\n\n---------------------------------------------");
                printf("\nhash: %ld" ,fileBlocks[i].hash);
                printf("\nfolder: %ld" ,fileBlocks[i].folderNum);
                printf("\nfile: %ld" ,fileBlocks[i].fileNum);
                printf("\nfolderName: %s" ,fileBlocks[i].folderName);
                printf("\nfileName: %s" ,fileBlocks[i].fileName);*/

                printf("\n%ld", fileBlocks[i -1].fileNum + 1);

                /*printf("\n\nhash: %ld" ,fileBlocks[i+1].hash);
                printf("\nfolder: %ld" ,fileBlocks[i +1].folderNum);
                printf("\nfile: %ld" ,fileBlocks[i+1].fileNum);
                printf("\nfolderName: %s" ,fileBlocks[i+1].folderName);
                printf("\nfileName: %s" ,fileBlocks[i+1].fileName);

                printf("\n---------------------------------------------");*/

                count++;
            }
        }
    }
    fclose(fp);

    fp = fopen("hashes_new3.txt","wb");

    char div = '|';
    char newLine = '\n';

    char buffer[MAX_PATH];
    for (i = 0; i < totalBlocks; i++)
    {
        sprintf(buffer,"%ld",fileBlocks[i].hash);
        fwrite(buffer,strlen(buffer),1,fp);
        fwrite(&div,1,1,fp);

        sprintf(buffer,"%ld",fileBlocks[i].folderNum);
        fwrite(buffer,strlen(buffer),1,fp);
        fwrite(&div,1,1,fp);

        sprintf(buffer,"%ld",fileBlocks[i].fileNum);
        fwrite(buffer,strlen(buffer),1,fp);
        fwrite(&div,1,1,fp);

        sprintf(buffer,"%s",fileBlocks[i].folderName);
        fwrite(buffer,strlen(buffer),1,fp);
        fwrite(&div,1,1,fp);

        sprintf(buffer,"%s",fileBlocks[i].fileName);
        fwrite(buffer,strlen(buffer),1,fp);
        fwrite(&newLine,1,1,fp);
    }

    fclose(fp);





    cout << "\n count:" << count << endl;
    return 0;
}
